<?php
// +--------------------------------------------------------------------------+
// | Contentteller(R) Update #9                                               |
// +--------------------------------------------------------------------------+
// | Copyright (C) 2002 - 2012 by Esselbach Internet Solutions                |
// | Available from http://www.contentteller.com                              |
// +--------------------------------------------------------------------------+
// | Contentteller is not free software. You may not redistribute this file   |
// | or its derivatives without written permission.                           |
// +--------------------------------------------------------------------------+
// | Contentteller is a registered trademark.                                 |
// +--------------------------------------------------------------------------+
// | Build: 824.97.120908-140829                                              |
// +--------------------------------------------------------------------------+

/**
 * @package Contentteller
 * @subpackage News
 * @copyright (C) 2002-2012 Esselbach Internet Solutions
 */

/**
 * function News
 * A function to show the news overview
 * @author Philipp Louis Esselbach
 */
function News( $page )
{
	global $database, $templates, $system, $preferences, $uwrapper, $user;
	if ( $preferences[ 'news_blocks' ] )
	{
		$preferences[ 'site_blocks_override' ] = $preferences[ 'news_default_blocks' ];
	}

	$templates -> initgzip();
	$main_templates = $templates -> preparetemplates( "'site_header','site_footer','site_menu_header','site_menu_item_header','site_menu_sub_item_header','site_menu_sub_item_footer','site_menu_footer','site_menu_header','site_menu_item_header','site_menu_sub_item_header','site_menu_sub_item_footer','site_menu_item_footer','site_menu_item_admin','site_menu_footer','site_block','site_block_alt1','site_block_alt2','site_login_anon','site_login_user','site_login_cookie','news_rss','news_header','news_empty','news_story_more','news_story','news_story_link','news_footer','news_story_featured','news_story_teaserimage','news_story_current_rss','news_story_current','news_story_pagenav_header','news_story_pagenav_first','news_story_pagenav_previous','news_story_pagenav_one','news_story_pagenav_link','news_story_pagenav_selected','news_story_pagenav_next','news_story_pagenav_last','news_story_pagenav_footer','news_story_2columns_header','news_story_2columns_middle','news_story_2columns_footer','news_story_rating_1star','news_story_rating_2stars','news_story_rating_3stars','news_story_rating_4stars','news_story_rating_5stars','news_story_rating_vote','news_story_rating_votes','news_story_rating_vote_link','news_story_rating_votes_link','news_story_author_posted','news_story_author_contributed','news_story_editlink','news_story_tags','news_story_tags_list','news_story_day_rss_header','news_story_day_rss_footer','news_story_day_header','news_story_day_footer','news_archive_frontpage_header','news_archive_frontpage','news_archive_frontpage_footer','news_archive','news_submission_form_quickadd','news_layout_main'", $preferences[ 'current_theme' ] );
	$insert = $system -> getinsert( $preferences, $main_templates );

	if( $page )
	{
		$opt = $system -> getpage( $page );
		$this_page = " (" . $opt . ")";
	}
	else
	{
		$opt = 1;
		$this_page = "";
	}

	$insert[ 'page_name' ] = htmlspecialchars( $preferences[ 'website_name' ] ) . $this_page;
	$insert[ 'page_description' ] = htmlspecialchars( $preferences[ 'website_description' ] );
	$insert[ 'page_keywords' ] = htmlspecialchars( $preferences[ 'website_keywords' ] );
	$currentdate = date( "Y-m-d H:i:s", mktime() );

	if( $preferences[ 'news_allow_rss' ] )
	{
		$insert[ 'page_rss' ] = $templates -> exectemplate( $main_templates[ 'news_rss_html' ], $main_templates[ 'news_rss_php' ], $insert );
	}

	echo $templates -> exectemplate( $main_templates[ 'site_header_html' ], $main_templates[ 'site_header_php' ], $insert );

	if( $preferences[ 'news_navigation' ] )
	{
		$insert[ 'news_header' ] = $templates -> exectemplate( $main_templates[ 'news_header_html' ], $main_templates[ 'news_header_php' ], $insert );
	}
	else
	{
		$insert[ 'news_header' ] = "";
	}

	if( $preferences[ 'news_allow_submissions' ] and $preferences[ 'news_quick_submissions' ] )
	{
		if( $preferences[ 'news_allow_unregsubmit' ] or $user[ 'user_status' ] )
		{
			$insert[ 'news_submission_form_quickadd' ] = $templates -> exectemplate( $main_templates[ 'news_submission_form_quickadd_html' ], $main_templates[ 'news_submission_form_quickadd_php' ], $insert );
		}
	}
	else
	{
		$insert[ 'news_submission_form_quickadd' ] = "";
	}

	if( $user[ 'user_status' ] == 1 )
	{
		$newsstory_status = "(newsstory_status = '0' OR newsstory_status = '1' OR newsstory_status = '3')";
	}
	elseif( $user[ 'user_status' ] == 2 or $user[ 'user_status' ] == 3 )
	{
		$newsstory_status = "(newsstory_status = '0' OR newsstory_status = '1' OR newsstory_status = '2' OR newsstory_status = '3' OR newsstory_status = '4')";
	}
	elseif( $user[ 'user_status' ] == 6 )
	{
		$newsstory_status = "(newsstory_status = '0' OR newsstory_status = '1' OR newsstory_status = '3' OR newsstory_status = '4')";
	}
	else
	{
		$newsstory_status = "(newsstory_status = '0' OR newsstory_status = '3')";
	}

	if( $preferences[ 'news_start_expire_date' ] )
	{
		$news_expire_sql = " AND newsstory_startdate < '" . $currentdate . "' AND (newsstory_expiredate > '" . $currentdate . "' OR newsstory_neverexpire = '1')";
	}
	else
	{
		$news_expire_sql = "";
	}

	if( $preferences[ 'news_remove_nofollow_age' ] )
	{
		$news_nofollow_age = date( "Y-m-d H:i:s", mktime() - 86400 * $preferences[ 'news_remove_nofollow_age' ] );
	}

	$channelslist = array();
	$query = $database -> dbquery( "SELECT newschannel_key, newschannel_name FROM " . DB_PREFIX . "esselbach_ct_newschannels WHERE (newschannel_website = '0' OR newschannel_website = '" . $preferences[ 'current_website' ] . "')");
	while( list( $newschannel_key, $newschannel_name ) = $database -> dbrow( $query ) )
	{
		$channelslist[ $newschannel_key ] = $newschannel_name;
	}

	if( $preferences[ 'news_featured' ] )
	{

		if( $preferences[ 'news_forum_comments' ] )
		{
			$newsstory_threads = array();
			$query = $database -> dbquery( "SELECT newsstory_thread FROM " . DB_PREFIX . "esselbach_ct_newsstories WHERE newsstory_sticky = '1' AND newsstory_frontpage = '1' AND " . $newsstory_status . " AND (newsstory_website = '0' OR newsstory_website = '" . $preferences[ 'current_website' ] . "')" . $news_expire_sql . " ORDER BY newsstory_position DESC, newsstory_date DESC" );

			if( $database -> dbrows( $query ) )
			{
				while( list( $newsstory_thread ) = $database -> dbrow( $query ) )
				{
					if( $newsstory_thread )
					{
						$newsstory_threads[ ] = "'" . $newsstory_thread . "'";
					}
				}

				$newsstory_threads_comments = $uwrapper -> getcomments( $newsstory_threads );
			}
		}

		$query = $database -> dbquery( "SELECT newsstory_id, newsstory_author, newsstory_channels, newsstory_title, newsstory_seo, newsstory_story, newsstory_extendedstory, newsstory_link, newsstory_tags, newsstory_teaser, newsstory_comments, newsstory_thread, newsstory_date, newsstory_fields, newsstory_views, newsstory_rating, newsstory_votes, newsstory_source, newsstory_sourceid, newsstory_sticky FROM " . DB_PREFIX . "esselbach_ct_newsstories WHERE newsstory_sticky = '1' AND newsstory_frontpage = '1' AND " . $newsstory_status . " AND (newsstory_website = '0' OR newsstory_website = '" . $preferences[ 'current_website' ] . "')" . $news_expire_sql . " ORDER BY newsstory_position DESC, newsstory_date DESC" );

		if( $database -> dbrows( $query ) )
		{
			$insert[ 'news_featured' ] = $templates -> exectemplate( $main_templates[ 'news_story_featured_html' ], $main_templates[ 'news_story_featured_php' ], $insert );

			while( list( $insert[ 'newsstory_id' ], $insert[ 'newsstory_author' ], $insert[ 'newsstory_channels_keys' ], $insert[ 'newsstory_title' ], $insert[ 'newsstory_seo' ], $insert[ 'newsstory_story' ], $insert[ 'newsstory_extendedstory' ], $insert[ 'newsstory_link' ], $insert[ 'newsstory_tags' ], $insert[ 'newsstory_teaser' ], $insert[ 'newsstory_comments' ], $insert[ 'newsstory_thread' ], $insert[ 'newsstory_date' ], $newsstory_fields, $insert[ 'newsstory_views' ], $insert[ 'newsstory_rating' ], $insert[ 'newsstory_votes' ], $insert[ 'newsstory_source' ], $insert[ 'newsstory_sourceid' ], $insert[ 'newsstory_sticky'] ) = $database -> dbrow( $query ) )
			{
				$insert[ 'newsstory_title' ] = htmlspecialchars( $insert[ 'newsstory_title' ] );
				$insert[ 'newsstory_author' ] = htmlspecialchars( $insert[ 'newsstory_author' ] );
				$insert[ 'newsstory_source' ] = htmlspecialchars( $insert[ 'newsstory_source' ] );

				if( $insert[ 'newsstory_source' ] )
				{
					$insert[ 'newsstory_author_by' ] = $templates -> exectemplate( $main_templates[ 'news_story_author_contributed_html' ], $main_templates[ 'news_story_author_contributed_php' ], $insert );
				}
				else
				{
					$insert[ 'newsstory_author_by' ] = $templates -> exectemplate( $main_templates[ 'news_story_author_posted_html' ], $main_templates[ 'news_story_author_posted_php' ], $insert );
				}

				$newsstory_channels = array();
				if( $insert[ 'newsstory_channels_keys' ] )
				{
					$channelsids = explode( ",", $insert[ 'newsstory_channels_keys' ] );
					foreach( $channelsids as $channelid )
					{
						$newsstory_channels[] = $channelslist[ $channelid ];
					}
				}
				$insert[ 'newsstory_channels' ] = implode(", ", $newsstory_channels );

				if( $preferences[ 'news_forum_comments' ] )
				{
					if( isset( $newsstory_threads_comments[ $insert[ 'newsstory_thread' ] ] ) )
					{
						$insert[ 'newsstory_comments' ] = $newsstory_threads_comments[ $insert[ 'newsstory_thread' ] ];
					}
				}

				if( $insert[ 'newsstory_teaser' ] )
				{
					$insert[ 'newsstory_teaserimage' ] = $templates -> exectemplate( $main_templates[ 'news_story_teaserimage_html' ], $main_templates[ 'news_story_teaserimage_php' ], $insert );
				}
				else
				{
					$insert[ 'newsstory_teaserimage' ] = "";
				}

				$insert[ 'newsstory_rating_line' ] = "";
				$insert[ 'newsstory_voting_line' ] = "";

				if( $preferences[ 'news_allow_rating' ] and !preg_match( "/Google|Yahoo|MSNBOT|lycos|Lycos|av\.com|live|jeeves|Twiceler/i", $_SERVER[ 'HTTP_USER_AGENT' ] ) )
				{
					if( $preferences[ 'news_votes_rating'] )
					{
						if( $preferences[ 'news_allow_unregrating' ] or $user[ 'user_status' ] )
						{
							if ( $insert[ 'newsstory_votes' ] == 1 )
							{
								$insert[ 'newsstory_voting_line' ] = $templates -> exectemplate( $main_templates[ 'news_story_rating_vote_link_html' ], $main_templates[ 'news_story_rating_vote_link_php' ], $insert );
							}
							else
							{
								$insert[ 'newsstory_voting_line' ] = $templates -> exectemplate( $main_templates[ 'news_story_rating_votes_link_html' ], $main_templates[ 'news_story_rating_votes_link_php' ], $insert );
							}
						}
						else
						{
							if ( $insert[ 'newsstory_votes' ] == 1 )
							{
								$insert[ 'newsstory_voting_line' ] = $templates -> exectemplate( $main_templates[ 'news_story_rating_vote_html' ], $main_templates[ 'news_story_rating_vote_php' ], $insert );
							}
							else
							{
								$insert[ 'newsstory_voting_line' ] = $templates -> exectemplate( $main_templates[ 'news_story_rating_votes_html' ], $main_templates[ 'news_story_rating_votes_php' ], $insert );
							}
						}
					}
					else
					{
						if ( $insert[ 'newsstory_votes' ] )
						{
							if( $insert[ 'newsstory_rating' ] == 5 )
							{
								$insert[ 'newsstory_rating_line' ] = $templates -> exectemplate( $main_templates[ 'news_story_rating_5stars_html' ], $main_templates[ 'news_story_rating_5stars_php' ], $insert );
							}
							elseif( $insert[ 'newsstory_rating' ] == 4 )
							{
								$insert[ 'newsstory_rating_line' ] = $templates -> exectemplate( $main_templates[ 'news_story_rating_4stars_html' ], $main_templates[ 'news_story_rating_4stars_php' ], $insert );
							}
							elseif( $insert[ 'newsstory_rating' ] == 3 )
							{
								$insert[ 'newsstory_rating_line' ] = $templates -> exectemplate( $main_templates[ 'news_story_rating_3stars_html' ], $main_templates[ 'news_story_rating_3stars_php' ], $insert );
							}
							elseif( $insert[ 'newsstory_rating' ] == 2 )
							{
								$insert[ 'newsstory_rating_line' ] = $templates -> exectemplate( $main_templates[ 'news_story_rating_2stars_html' ], $main_templates[ 'news_story_rating_2stars_php' ], $insert );
							}
							elseif( $insert[ 'newsstory_rating' ] < 2 )
							{
								$insert[ 'newsstory_rating_line' ] = $templates -> exectemplate( $main_templates[ 'news_story_rating_1star_html' ], $main_templates[ 'news_story_rating_1star_php' ], $insert );
							}
						}
					}
				}

				if( $user[ 'user_status' ] == 2 and $insert[ 'newsstory_author' ] == $user[ 'user_name' ] )
				{
					$insert[ 'newsstory_edit' ] = $templates -> exectemplate( $main_templates[ 'news_story_editlink_html' ], $main_templates[ 'news_story_editlink_php' ], $insert );
				}
				else
				{
					$insert[ 'newsstory_edit' ] = "";
				}

				if( $insert[ 'newsstory_extendedstory' ] )
				{
					$insert[ 'newsstory_story' ] .= $templates -> exectemplate( $main_templates[ 'news_story_more_html' ], $main_templates[ 'news_story_more_php' ], $insert );
				}
				elseif( $insert[ 'newsstory_link' ] )
				{
					$insert[ 'newsstory_story' ] .= $templates -> exectemplate( $main_templates[ 'news_story_link_html' ], $main_templates[ 'news_story_link_php' ], $insert );
				}

				if( $newsstory_fields )
				{
					$newsstory_fields_array = explode( "|", $newsstory_fields );

					for( $f = 0; $f < 24; $f++ )
					{
						$field = $f + 1;
						$insert[ 'newsstory_extra' . $field ] = $system -> decode( $newsstory_fields_array[ $f ] );
					}
				}
				else
				{
					for( $f = 1; $f < 25; $f++ )
					{
						$insert[ 'newsstory_extra' . $f ] = "";
					}
				}

				if( $insert[ 'newsstory_tags' ] )
				{
					$tags = explode( ",", $insert[ 'newsstory_tags' ] );
					$tags_array = array();

					foreach( $tags as $tag )
					{
						if( $tag )
						{
							$insert[ 'newsstory_tag' ] = ltrim( rtrim( $tag ) );
							$insert[ 'newsstory_tag_seo' ] = $system -> doseo( $insert[ 'newsstory_tag' ] );
							$tags_array[ ] = $templates -> exectemplate( $main_templates[ 'news_story_tags_list_html' ], $main_templates[ 'news_story_tags_list_php' ], $insert );
						}
					}

					$insert[ 'newsstory_tags_list' ] = implode( ",", $tags_array );
					$insert[ 'newsstory_tags' ] = $templates -> exectemplate( $main_templates[ 'news_story_tags_html' ], $main_templates[ 'news_story_tags_php' ], $insert );
				}

				if( $preferences[ 'news_window_url' ] )
				{
					$insert[ 'newsstory_story' ] = str_replace( " rel=\"nofollow\"", " rel=\"nofollow\" onclick=\"window.open(this.href);return false;\"", $insert[ 'newsstory_story' ] );
				}

				if( $preferences[ 'news_remove_nofollow' ] )
				{
					if( $preferences[ 'news_remove_nofollow_age' ] )
					{
						if ( $insert[ 'newsstory_date' ] > $news_nofollow_age )
						{
							$insert[ 'newsstory_story' ] = str_replace( " rel=\"nofollow\"", "", $insert[ 'newsstory_story' ] );
						}
					}
					else
					{
						$insert[ 'newsstory_story' ] = str_replace( " rel=\"nofollow\"", "", $insert[ 'newsstory_story' ] );
					}
				}

				$insert[ 'newsstory_date' ] = $system -> convertdate( $insert[ 'newsstory_date' ], $preferences[ 'news_dateformat' ], $preferences[ 'website_timezone' ] );
				$insert[ 'news_featured' ] .= $templates -> exectemplate( $main_templates[ 'news_story_html' ], $main_templates[ 'news_story_php' ], $insert );
			}
		}
	}
	else
	{
		$insert[ 'news_featured' ] = "";
	}

	$insert[ 'news_story' ] = "";
	$insert[ 'news_archive' ] = "";

	if( $preferences[ 'news_pages_frontpage' ] )
	{
		$news_dbpage = $opt - 1;
		if( $preferences[ 'news_sortbydays' ] )
		{
			$query = $database -> dbquery( "SELECT DISTINCT SUBSTRING_INDEX(newsstory_date,' ','1') FROM " . DB_PREFIX . "esselbach_ct_newsstories WHERE " . $newsstory_status . " AND newsstory_sticky = '0' AND newsstory_frontpage = '1' AND (newsstory_website = '0' OR newsstory_website = '" . $preferences[ 'current_website' ] . "')" . $news_expire_sql . " ORDER BY newsstory_date" );
			$news_all_stories = $database -> dbrows( $query );
			$news_page = $news_dbpage * $preferences[ 'news_max_days' ];
			$news_pages = ceil( $news_all_stories / $preferences[ 'news_max_days' ] );
		}
		else
		{
			$query = $database -> dbquery( "SELECT newsstory_id FROM " . DB_PREFIX . "esselbach_ct_newsstories WHERE " . $newsstory_status . " AND newsstory_sticky = '0' AND newsstory_frontpage = '1' AND (newsstory_website = '0' OR newsstory_website = '" . $preferences[ 'current_website' ] . "')" . $news_expire_sql . " ORDER BY newsstory_date" );
			$news_all_stories = $database -> dbrows( $query );
			$news_page = $news_dbpage * $preferences[ 'news_max_stories' ];
			$news_pages = ceil( $news_all_stories / $preferences[ 'news_max_stories' ] );
		}

		if( ( $news_page < $news_all_stories ) and( $news_pages > 1 ) )
		{
			$insert[ 'news_totalpages' ] = $news_pages;
			$insert[ 'news_story_pagenav' ] = $templates -> exectemplate( $main_templates[ 'news_story_pagenav_header_html' ], $main_templates[ 'news_story_pagenav_header_php' ], $insert );

			if( !$opt )
			{
				$opt = 1;
			}

			if( $news_pages > 6 )
			{
				$news_pages_new = $opt + 1;
				$news_pages_old = $opt - 1;

				if( $news_pages_new < 3 )
				{
					$news_pages_cur = 3;
				}
				else
				{
					$news_pages_cur = $news_pages_new;
				}

				if( $opt > 2 )
				{
					$insert[ 'news_story_pagenav' ] .= $templates -> exectemplate( $main_templates[ 'news_story_pagenav_first_html' ], $main_templates[ 'news_story_pagenav_first_php' ], $insert );
				}

				$current = $news_pages_cur - 2;
				$forward = $current + 4;
				$backward = $news_pages - 3;

				if( $forward > $news_pages )
				{
					$insert[ 'news_previous' ] .= $news_pages_old;
					$insert[ 'news_story_pagenav' ] .= $templates -> exectemplate( $main_templates[ 'news_story_pagenav_previous_html' ], $main_templates[ 'news_story_pagenav_previous_php' ], $insert );

					for( $i = $backward; $i <= $news_pages; $i++ )
					{
						$insert[ 'news_page' ] = $i;

						if( $opt == $i )
						{
							$insert[ 'news_story_pagenav' ] .= $templates -> exectemplate( $main_templates[ 'news_story_pagenav_selected_html' ], $main_templates[ 'news_story_pagenav_selected_php' ], $insert );
						}
						else
						{
							$insert[ 'news_link' ] = $i;
							if( $i == 1 )
							{
								$insert[ 'news_story_pagenav' ] .= $templates -> exectemplate( $main_templates[ 'news_story_pagenav_one_html' ], $main_templates[ 'news_story_pagenav_one_php' ], $insert );
							}
							else
							{
								$insert[ 'news_story_pagenav' ] .= $templates -> exectemplate( $main_templates[ 'news_story_pagenav_link_html' ], $main_templates[ 'news_story_pagenav_link_php' ], $insert );
							}
						}
					}
				}
				else
				{
					if( $news_pages_old > 3 )
					{
						$insert[ 'news_previous' ] = $news_pages_old;
						$insert[ 'news_story_pagenav' ] .= $templates -> exectemplate( $main_templates[ 'news_story_pagenav_previous_html' ], $main_templates[ 'news_story_pagenav_previous_php' ], $insert );
					}

					for( $i = $current; $i < $forward; $i++ )
					{
						$insert[ 'news_page' ] = $i;

						if( $opt == $i )
						{
							$insert[ 'news_story_pagenav' ] .= $templates -> exectemplate( $main_templates[ 'news_story_pagenav_selected_html' ], $main_templates[ 'news_story_pagenav_selected_php' ], $insert );
						}
						else
						{
							$insert[ 'news_link' ] = $i;
							if( $i == 1 )
							{
								$insert[ 'news_story_pagenav' ] .= $templates -> exectemplate( $main_templates[ 'news_story_pagenav_one_html' ], $main_templates[ 'news_story_pagenav_one_php' ], $insert );
							}
							else
							{
								$insert[ 'news_story_pagenav' ] .= $templates -> exectemplate( $main_templates[ 'news_story_pagenav_link_html' ], $main_templates[ 'news_story_pagenav_link_php' ], $insert );
							}
						}
					}

					$insert[ 'news_next' ] = $news_pages_new;
					$insert[ 'news_story_pagenav' ] .= $templates -> exectemplate( $main_templates[ 'news_story_pagenav_next_html' ], $main_templates[ 'news_story_pagenav_next_php' ], $insert );
					$insert[ 'news_last' ] = $news_pages;
					$insert[ 'news_story_pagenav' ] .= $templates -> exectemplate( $main_templates[ 'news_story_pagenav_last_html' ], $main_templates[ 'news_story_pagenav_last_php' ], $insert );
				}
			}
			else
			{
				for( $i = 1; $i <= $news_pages; $i++ )
				{
					$insert[ 'news_page' ] = $i;
					$insert[ 'news_link' ] = $i;

					if( $opt == $i )
					{
						$insert[ 'news_story_pagenav' ] .= $templates -> exectemplate( $main_templates[ 'news_story_pagenav_selected_html' ], $main_templates[ 'news_story_pagenav_selected_php' ], $insert );
					}
					else
					{
						if( $i == 1 )
						{
							$insert[ 'news_story_pagenav' ] .= $templates -> exectemplate( $main_templates[ 'news_story_pagenav_one_html' ], $main_templates[ 'news_story_pagenav_one_php' ], $insert );
						}
						else
						{
							$insert[ 'news_story_pagenav' ] .= $templates -> exectemplate( $main_templates[ 'news_story_pagenav_link_html' ], $main_templates[ 'news_story_pagenav_link_php' ], $insert );
						}
					}
				}
			}

			$insert[ 'news_story_pagenav' ] .= $templates -> exectemplate( $main_templates[ 'news_story_pagenav_footer_html' ], $main_templates[ 'news_story_pagenav_footer_php' ], $insert );
		}
		else
		{
			$news_page = 0;
		}
	}
	else
	{
		$insert[ 'news_story_pagenav' ] = "";
	}

	if( $preferences[ 'news_sortbydays' ] )
	{
		if( ( $preferences[ 'news_pages_frontpage' ] ) and ( $opt > 1 ) )
		{
			$query = $database -> dbquery( "SELECT DISTINCT SUBSTRING_INDEX(newsstory_date,' ','1') FROM " . DB_PREFIX . "esselbach_ct_newsstories WHERE " . $newsstory_status . " AND newsstory_sticky = '0' AND newsstory_frontpage = '1' AND (newsstory_website = '0' OR newsstory_website = '" . $preferences[ 'current_website' ] . "')" . $news_expire_sql . " ORDER BY newsstory_date DESC LIMIT " . $news_page . "," . intval( $preferences[ 'news_max_days' ] ) );

		}
		else
		{
			$query = $database -> dbquery( "SELECT DISTINCT SUBSTRING_INDEX(newsstory_date,' ','1') FROM " . DB_PREFIX . "esselbach_ct_newsstories WHERE " . $newsstory_status . " AND newsstory_sticky = '0' AND newsstory_frontpage = '1' AND (newsstory_website = '0' OR newsstory_website = '" . $preferences[ 'current_website' ] . "')" . $news_expire_sql . " ORDER BY newsstory_date DESC LIMIT " . intval( $preferences[ 'news_max_days' ] ) );
		}

		if( $database -> dbrows( $query ) )
		{
			$story_date_array = array();

			while( list( $newsstory_date ) = $database -> dbrow( $query ) )
			{
				$story_date_array[ ] = $newsstory_date;
			}

			for( $i = 0; $i < count( $story_date_array ); $i++ )
			{
				$story_time_array = explode( "-", $story_date_array[ $i ] );
				$insert[ 'newsstory_day' ] = strftime( $preferences[ 'news_day_dateformat' ], mktime( 0, 0, 0, $story_time_array[ 1 ], $story_time_array[ 2 ], $story_time_array[ 0 ] ) );

				if( $preferences[ 'news_allow_rss' ] )
				{
					$insert[ 'news_story' ] .= $templates -> exectemplate( $main_templates[ 'news_story_day_rss_header_html' ], $main_templates[ 'news_story_day_rss_header_php' ], $insert );
				}
				else
				{
					$insert[ 'news_story' ] .= $templates -> exectemplate( $main_templates[ 'news_story_day_header_html' ], $main_templates[ 'news_story_day_header_php' ], $insert );
				}

				$newsrow = 0;

				if( $preferences[ 'news_forum_comments' ] )
				{
					$newsstory_threads = array();
					$query = $database -> dbquery( "SELECT newsstory_thread FROM " . DB_PREFIX . "esselbach_ct_newsstories WHERE (newsstory_date LIKE '%" . $story_date_array[ $i ] . "%') AND newsstory_sticky = '0' AND newsstory_frontpage = '1' AND " . $newsstory_status . " AND (newsstory_website = '0' OR newsstory_website = '" . $preferences[ 'current_website' ] . "')" . $news_expire_sql . " ORDER BY newsstory_position DESC, newsstory_date DESC" );

					if( $database -> dbrows( $query ) )
					{
						while( list( $newsstory_thread ) = $database -> dbrow( $query ) )
						{
							if( $newsstory_thread )
							{
								$newsstory_threads[ ] = "'" . $newsstory_thread . "'";
							}
						}

						$newsstory_threads_comments = $uwrapper -> getcomments( $newsstory_threads );
					}
				}

				$query = $database -> dbquery( "SELECT newsstory_id, newsstory_author, newsstory_channels, newsstory_title, newsstory_seo, newsstory_story, newsstory_extendedstory, newsstory_link, newsstory_tags, newsstory_teaser, newsstory_comments, newsstory_thread, newsstory_date, newsstory_fields, newsstory_views, newsstory_rating, newsstory_votes, newsstory_source, newsstory_sourceid, newsstory_sticky FROM " . DB_PREFIX . "esselbach_ct_newsstories WHERE (newsstory_date LIKE '%" . $story_date_array[ $i ] . "%') AND newsstory_sticky = '0' AND newsstory_frontpage = '1' AND " . $newsstory_status . " AND (newsstory_website = '0' OR newsstory_website = '" . $preferences[ 'current_website' ] . "')" . $news_expire_sql . " ORDER BY newsstory_position DESC, newsstory_date DESC" );

				while( list( $insert[ 'newsstory_id' ], $insert[ 'newsstory_author' ], $insert[ 'newsstory_channels_keys' ], $insert[ 'newsstory_title' ], $insert[ 'newsstory_seo' ], $insert[ 'newsstory_story' ], $insert[ 'newsstory_extendedstory' ], $insert[ 'newsstory_link' ], $insert[ 'newsstory_tags' ], $insert[ 'newsstory_teaser' ], $insert[ 'newsstory_comments' ], $insert[ 'newsstory_thread' ], $insert[ 'newsstory_date' ], $newsstory_fields, $insert[ 'newsstory_views' ], $insert[ 'newsstory_rating' ], $insert[ 'newsstory_votes' ], $insert[ 'newsstory_source' ], $insert[ 'newsstory_sourceid' ], $insert[ 'newsstory_sticky' ] ) = $database -> dbrow( $query ) )
				{
					$insert[ 'newsstory_title' ] = htmlspecialchars( $insert[ 'newsstory_title' ] );
					$insert[ 'newsstory_author' ] = htmlspecialchars( $insert[ 'newsstory_author' ] );
					$insert[ 'newsstory_source' ] = htmlspecialchars( $insert[ 'newsstory_source' ] );

					if( $insert[ 'newsstory_source' ] )
					{
						$insert[ 'newsstory_author_by' ] = $templates -> exectemplate( $main_templates[ 'news_story_author_contributed_html' ], $main_templates[ 'news_story_author_contributed_php' ], $insert );
					}
					else
					{
						$insert[ 'newsstory_author_by' ] = $templates -> exectemplate( $main_templates[ 'news_story_author_posted_html' ], $main_templates[ 'news_story_author_posted_php' ], $insert );
					}

					$newsstory_channels = array();
					if( $insert[ 'newsstory_channels_keys' ] )
					{
						$channelsids = explode( ",", $insert[ 'newsstory_channels_keys' ] );
						foreach( $channelsids as $channelid )
						{
							$newsstory_channels[] = $channelslist[ $channelid ];
						}
					}
					$insert[ 'newsstory_channels' ] = implode(", ", $newsstory_channels );

					if( $preferences[ 'news_forum_comments' ] )
					{
						if( isset( $newsstory_threads_comments[ $insert[ 'newsstory_thread' ] ] ) )
						{
							$insert[ 'newsstory_comments' ] = $newsstory_threads_comments[ $insert[ 'newsstory_thread' ] ];
						}
					}

					if( $insert[ 'newsstory_teaser' ] )
					{
						$insert[ 'newsstory_teaserimage' ] = $templates -> exectemplate( $main_templates[ 'news_story_teaserimage_html' ], $main_templates[ 'news_story_teaserimage_php' ], $insert );
					}
					else
					{
						$insert[ 'newsstory_teaserimage' ] = "";
					}

					$insert[ 'newsstory_rating_line' ] = "";
					$insert[ 'newsstory_voting_line' ] = "";

					if( $preferences[ 'news_allow_rating' ] and !preg_match( "/Google|Yahoo|MSNBOT|lycos|Lycos|av\.com|live|jeeves|Twiceler/i", $_SERVER[ 'HTTP_USER_AGENT' ] ) )
					{
						if( $preferences[ 'news_votes_rating'] )
						{
							if( $preferences[ 'news_allow_unregrating' ] or $user[ 'user_status' ] )
							{
								if ( $insert[ 'newsstory_votes' ] == 1 )
								{
									$insert[ 'newsstory_voting_line' ] = $templates -> exectemplate( $main_templates[ 'news_story_rating_vote_link_html' ], $main_templates[ 'news_story_rating_vote_link_php' ], $insert );
								}
								else
								{
									$insert[ 'newsstory_voting_line' ] = $templates -> exectemplate( $main_templates[ 'news_story_rating_votes_link_html' ], $main_templates[ 'news_story_rating_votes_link_php' ], $insert );
								}
							}
							else
							{
								if ( $insert[ 'newsstory_votes' ] == 1 )
								{
									$insert[ 'newsstory_voting_line' ] = $templates -> exectemplate( $main_templates[ 'news_story_rating_vote_html' ], $main_templates[ 'news_story_rating_vote_php' ], $insert );
								}
								else
								{
									$insert[ 'newsstory_voting_line' ] = $templates -> exectemplate( $main_templates[ 'news_story_rating_votes_html' ], $main_templates[ 'news_story_rating_votes_php' ], $insert );
								}
							}
						}
						else
						{
							if ( $insert[ 'newsstory_votes' ] )
							{
								if( $insert[ 'newsstory_rating' ] == 5 )
								{
									$insert[ 'newsstory_rating_line' ] = $templates -> exectemplate( $main_templates[ 'news_story_rating_5stars_html' ], $main_templates[ 'news_story_rating_5stars_php' ], $insert );
								}
								elseif( $insert[ 'newsstory_rating' ] == 4 )
								{
									$insert[ 'newsstory_rating_line' ] = $templates -> exectemplate( $main_templates[ 'news_story_rating_4stars_html' ], $main_templates[ 'news_story_rating_4stars_php' ], $insert );
								}
								elseif( $insert[ 'newsstory_rating' ] == 3 )
								{
									$insert[ 'newsstory_rating_line' ] = $templates -> exectemplate( $main_templates[ 'news_story_rating_3stars_html' ], $main_templates[ 'news_story_rating_3stars_php' ], $insert );
								}
								elseif( $insert[ 'newsstory_rating' ] == 2 )
								{
									$insert[ 'newsstory_rating_line' ] = $templates -> exectemplate( $main_templates[ 'news_story_rating_2stars_html' ], $main_templates[ 'news_story_rating_2stars_php' ], $insert );
								}
								elseif( $insert[ 'newsstory_rating' ] < 2 )
								{
									$insert[ 'newsstory_rating_line' ] = $templates -> exectemplate( $main_templates[ 'news_story_rating_1star_html' ], $main_templates[ 'news_story_rating_1star_php' ], $insert );
								}
							}
						}
					}

					if( $user[ 'user_status' ] == 2 and $insert[ 'newsstory_author' ] == $user[ 'user_name' ] )
					{
						$insert[ 'newsstory_edit' ] = $templates -> exectemplate( $main_templates[ 'news_story_editlink_html' ], $main_templates[ 'news_story_editlink_php' ], $insert );
					}
					else
					{
						$insert[ 'newsstory_edit' ] = "";
					}

					if( $insert[ 'newsstory_extendedstory' ] )
					{
						$insert[ 'newsstory_story' ] .= $templates -> exectemplate( $main_templates[ 'news_story_more_html' ], $main_templates[ 'news_story_more_php' ], $insert );
					}
					elseif( $insert[ 'newsstory_link' ] )
					{
						$insert[ 'newsstory_story' ] .= $templates -> exectemplate( $main_templates[ 'news_story_link_html' ], $main_templates[ 'news_story_link_php' ], $insert );
					}

					if( $newsstory_fields )
					{
						$newsstory_fields_array = explode( "|", $newsstory_fields );

						for( $f = 0; $f < 24; $f++ )
						{
							$field = $f + 1;
							$insert[ 'newsstory_extra' . $field ] = $system -> decode( $newsstory_fields_array[ $f ] );
						}
					}
					else
					{
						for( $f = 1; $f < 25; $f++ )
						{
							$insert[ 'newsstory_extra' . $f ] = "";
						}
					}

					if( $insert[ 'newsstory_tags' ] )
					{
						$tags = explode( ",", $insert[ 'newsstory_tags' ] );
						$tags_array = array();

						foreach( $tags as $tag )
						{
							if( $tag )
							{
								$insert[ 'newsstory_tag' ] = ltrim( rtrim( $tag ) );
								$insert[ 'newsstory_tag_seo' ] = $system -> doseo( $insert[ 'newsstory_tag' ] );
								$tags_array[ ] = $templates -> exectemplate( $main_templates[ 'news_story_tags_list_html' ], $main_templates[ 'news_story_tags_list_php' ], $insert );
							}
						}

						$insert[ 'newsstory_tags_list' ] = implode( ",", $tags_array );
						$insert[ 'newsstory_tags' ] = $templates -> exectemplate( $main_templates[ 'news_story_tags_html' ], $main_templates[ 'news_story_tags_php' ], $insert );
					}

					if( $preferences[ 'news_window_url' ] )
					{
						$insert[ 'newsstory_story' ] = str_replace( " rel=\"nofollow\"", " rel=\"nofollow\" onclick=\"window.open(this.href);return false;\"", $insert[ 'newsstory_story' ] );
					}

					if( $preferences[ 'news_remove_nofollow' ] )
					{
						if( $preferences[ 'news_remove_nofollow_age' ] )
						{
							if ( $insert[ 'newsstory_date' ] > $news_nofollow_age )
							{
								$insert[ 'newsstory_story' ] = str_replace( " rel=\"nofollow\"", "", $insert[ 'newsstory_story' ] );
							}
						}
						else
						{
							$insert[ 'newsstory_story' ] = str_replace( " rel=\"nofollow\"", "", $insert[ 'newsstory_story' ] );
						}
					}

					$insert[ 'newsstory_date' ] = $system -> convertdate( $insert[ 'newsstory_date' ], $preferences[ 'news_dateformat' ], $preferences[ 'website_timezone' ] );

					if( $preferences[ 'news_2columns' ] )
					{

						if( !$newsrow )
						{
							$insert[ 'news_story' ] .= $templates -> exectemplate( $main_templates[ 'news_story_2columns_header_html' ], $main_templates[ 'news_story_2columns_header_php' ], $insert );
							$newsrow = 1;
						}
						elseif( $newsrow == 1 )
						{
							$insert[ 'news_story' ] .= $templates -> exectemplate( $main_templates[ 'news_story_2columns_middle_html' ], $main_templates[ 'news_story_2columns_middle_php' ], $insert );
							$newsrow = 2;
						}
					}

					$insert[ 'news_story' ] .= $templates -> exectemplate( $main_templates[ 'news_story_html' ], $main_templates[ 'news_story_php' ], $insert );

					if( $preferences[ 'news_2columns' ] and $newsrow == 2 )
					{
						$insert[ 'news_story' ] .= $templates -> exectemplate( $main_templates[ 'news_story_2columns_footer_html' ], $main_templates[ 'news_story_2columns_footer_php' ], $insert );
						$newsrow = 0;
					}
				}

				if( $preferences[ 'news_2columns' ] and $newsrow == 1 )
				{
					$insert[ 'news_story' ] .= $templates -> exectemplate( $main_templates[ 'news_story_2columns_middle_html' ], $main_templates[ 'news_story_2columns_middle_php' ], $insert );
					$insert[ 'news_story' ] .= $templates -> exectemplate( $main_templates[ 'news_story_2columns_footer_html' ], $main_templates[ 'news_story_2columns_footer_php' ], $insert );
				}

				if( $preferences[ 'news_allow_rss' ] )
				{
					$insert[ 'news_story' ] .= $templates -> exectemplate( $main_templates[ 'news_story_day_rss_footer_html' ], $main_templates[ 'news_story_day_rss_footer_php' ], $insert );
				}
				else
				{
					$insert[ 'news_story' ] .= $templates -> exectemplate( $main_templates[ 'news_story_day_footer_html' ], $main_templates[ 'news_story_day_footer_php' ], $insert );
				}
			}
		}
		else
		{
			$insert[ 'news_story' ] .= $templates -> exectemplate( $main_templates[ 'news_empty_html' ], $main_templates[ 'news_empty_php' ], $insert );
		}
	}
	else
	{
		if( $preferences[ 'news_allow_rss' ] )
		{
			$insert[ 'news_story' ] .= $templates -> exectemplate( $main_templates[ 'news_story_current_rss_html' ], $main_templates[ 'news_story_current_rss_php' ], $insert );
		}
		else
		{
			$insert[ 'news_story' ] .= $templates -> exectemplate( $main_templates[ 'news_story_current_html' ], $main_templates[ 'news_story_current_php' ], $insert );
		}

		$newsrow = 0;

		if( $preferences[ 'news_forum_comments' ] )
		{
			$newsstory_threads = array();
			if( ( $preferences[ 'news_pages_frontpage' ] ) and ( $opt > 1 ) )
			{
				$query = $database -> dbquery( "SELECT newsstory_thread FROM " . DB_PREFIX . "esselbach_ct_newsstories WHERE " . $newsstory_status . " AND newsstory_sticky = '0' AND newsstory_frontpage = '1' AND (newsstory_website = '0' OR newsstory_website = '" . $preferences[ 'current_website' ] . "')" . $news_expire_sql . " ORDER BY newsstory_position DESC, newsstory_date DESC LIMIT " . $news_page . "," . intval( $preferences[ 'news_max_stories' ] ) );
			}
			else
			{
				$query = $database -> dbquery( "SELECT newsstory_thread FROM " . DB_PREFIX . "esselbach_ct_newsstories WHERE " . $newsstory_status . " AND newsstory_sticky = '0' AND newsstory_frontpage = '1' AND (newsstory_website = '0' OR newsstory_website = '" . $preferences[ 'current_website' ] . "')" . $news_expire_sql . " ORDER BY newsstory_position DESC, newsstory_date DESC LIMIT " . intval( $preferences[ 'news_max_stories' ] ) );
			}

			if( $database -> dbrows( $query ) )
			{
				while( list( $newsstory_thread ) = $database -> dbrow( $query ) )
				{
					if( $newsstory_thread )
					{
						$newsstory_threads[ ] = "'" . $newsstory_thread . "'";
					}
				}

				$newsstory_threads_comments = $uwrapper -> getcomments( $newsstory_threads );
			}
		}

		if( ( $preferences[ 'news_pages_frontpage' ] ) and ( $opt > 1 ) )
		{
			$query = $database -> dbquery( "SELECT newsstory_id, newsstory_author, newsstory_channels, newsstory_title, newsstory_seo, newsstory_story, newsstory_extendedstory, newsstory_link, newsstory_tags, newsstory_teaser, newsstory_comments, newsstory_thread, newsstory_date, newsstory_fields, newsstory_views, newsstory_rating, newsstory_votes, newsstory_source, newsstory_sourceid, newsstory_sticky FROM " . DB_PREFIX . "esselbach_ct_newsstories WHERE " . $newsstory_status . " AND newsstory_sticky = '0' AND newsstory_frontpage = '1' AND (newsstory_website = '0' OR newsstory_website = '" . $preferences[ 'current_website' ] . "')" . $news_expire_sql . " ORDER BY newsstory_position DESC, newsstory_date DESC LIMIT " . $news_page . "," . intval( $preferences[ 'news_max_stories' ] ) );
		}
		else
		{
			$query = $database -> dbquery( "SELECT newsstory_id, newsstory_author, newsstory_channels, newsstory_title, newsstory_seo, newsstory_story, newsstory_extendedstory, newsstory_link, newsstory_tags, newsstory_teaser, newsstory_comments, newsstory_thread, newsstory_date, newsstory_fields, newsstory_views, newsstory_rating, newsstory_votes, newsstory_source, newsstory_sourceid, newsstory_sticky FROM " . DB_PREFIX . "esselbach_ct_newsstories WHERE " . $newsstory_status . " AND newsstory_sticky = '0' AND newsstory_frontpage = '1' AND (newsstory_website = '0' OR newsstory_website = '" . $preferences[ 'current_website' ] . "')" . $news_expire_sql . " ORDER BY newsstory_position DESC, newsstory_date DESC LIMIT " . intval( $preferences[ 'news_max_stories' ] ) );
		}

		if( $database -> dbrows( $query ) )
		{
			while( list( $insert[ 'newsstory_id' ], $insert[ 'newsstory_author' ], $insert[ 'newsstory_channels_keys' ], $insert[ 'newsstory_title' ], $insert[ 'newsstory_seo' ], $insert[ 'newsstory_story' ], $insert[ 'newsstory_extendedstory' ], $insert[ 'newsstory_link' ], $insert[ 'newsstory_tags' ], $insert[ 'newsstory_teaser' ], $insert[ 'newsstory_comments' ], $insert[ 'newsstory_thread' ], $insert[ 'newsstory_date' ], $newsstory_fields, $insert[ 'newsstory_views' ], $insert[ 'newsstory_rating' ], $insert[ 'newsstory_votes' ], $insert[ 'newsstory_source' ], $insert[ 'newsstory_sourceid' ], $insert[ 'newsstory_sticky' ] ) = $database -> dbrow( $query ) )
			{
				$insert[ 'newsstory_title' ] = htmlspecialchars( $insert[ 'newsstory_title' ] );
				$insert[ 'newsstory_author' ] = htmlspecialchars( $insert[ 'newsstory_author' ] );
				$insert[ 'newsstory_source' ] = htmlspecialchars( $insert[ 'newsstory_source' ] );

				if( $insert[ 'newsstory_source' ] )
				{
					$insert[ 'newsstory_author_by' ] = $templates -> exectemplate( $main_templates[ 'news_story_author_contributed_html' ], $main_templates[ 'news_story_author_contributed_php' ], $insert );
				}
				else
				{
					$insert[ 'newsstory_author_by' ] = $templates -> exectemplate( $main_templates[ 'news_story_author_posted_html' ], $main_templates[ 'news_story_author_posted_php' ], $insert );
				}

				$newsstory_channels = array();
				if( $insert[ 'newsstory_channels_keys' ] )
				{
					$channelsids = explode( ",", $insert[ 'newsstory_channels_keys' ] );
					foreach( $channelsids as $channelid )
					{
						$newsstory_channels[] = $channelslist[ $channelid ];
					}
				}
				$insert[ 'newsstory_channels' ] = implode(", ", $newsstory_channels );

				if( $preferences[ 'news_forum_comments' ] )
				{
					if( isset( $newsstory_threads_comments[ $insert[ 'newsstory_thread' ] ] ) )
					{
						$insert[ 'newsstory_comments' ] = $newsstory_threads_comments[ $insert[ 'newsstory_thread' ] ];
					}
				}

				if( $insert[ 'newsstory_teaser' ] )
				{
					$insert[ 'newsstory_teaserimage' ] = $templates -> exectemplate( $main_templates[ 'news_story_teaserimage_html' ], $main_templates[ 'news_story_teaserimage_php' ], $insert );
				}
				else
				{
					$insert[ 'newsstory_teaserimage' ] = "";
				}

				$insert[ 'newsstory_rating_line' ] = "";
				$insert[ 'newsstory_voting_line' ] = "";

				if( $preferences[ 'news_allow_rating' ] and !preg_match( "/Google|Yahoo|MSNBOT|lycos|Lycos|av\.com|live|jeeves|Twiceler/i", $_SERVER[ 'HTTP_USER_AGENT' ] ) )
				{
					if( $preferences[ 'news_votes_rating'] )
					{
						if( $preferences[ 'news_allow_unregrating' ] or $user[ 'user_status' ] )
						{
							if ( $insert[ 'newsstory_votes' ] == 1 )
							{
								$insert[ 'newsstory_voting_line' ] = $templates -> exectemplate( $main_templates[ 'news_story_rating_vote_link_html' ], $main_templates[ 'news_story_rating_vote_link_php' ], $insert );
							}
							else
							{
								$insert[ 'newsstory_voting_line' ] = $templates -> exectemplate( $main_templates[ 'news_story_rating_votes_link_html' ], $main_templates[ 'news_story_rating_votes_link_php' ], $insert );
							}
						}
						else
						{
							if ( $insert[ 'newsstory_votes' ] == 1 )
							{
								$insert[ 'newsstory_voting_line' ] = $templates -> exectemplate( $main_templates[ 'news_story_rating_vote_html' ], $main_templates[ 'news_story_rating_vote_php' ], $insert );
							}
							else
							{
								$insert[ 'newsstory_voting_line' ] = $templates -> exectemplate( $main_templates[ 'news_story_rating_votes_html' ], $main_templates[ 'news_story_rating_votes_php' ], $insert );
							}
						}
					}
					else
					{
						if ( $insert[ 'newsstory_votes' ] )
						{
							if( $insert[ 'newsstory_rating' ] == 5 )
							{
								$insert[ 'newsstory_rating_line' ] = $templates -> exectemplate( $main_templates[ 'news_story_rating_5stars_html' ], $main_templates[ 'news_story_rating_5stars_php' ], $insert );
							}
							elseif( $insert[ 'newsstory_rating' ] == 4 )
							{
								$insert[ 'newsstory_rating_line' ] = $templates -> exectemplate( $main_templates[ 'news_story_rating_4stars_html' ], $main_templates[ 'news_story_rating_4stars_php' ], $insert );
							}
							elseif( $insert[ 'newsstory_rating' ] == 3 )
							{
								$insert[ 'newsstory_rating_line' ] = $templates -> exectemplate( $main_templates[ 'news_story_rating_3stars_html' ], $main_templates[ 'news_story_rating_3stars_php' ], $insert );
							}
							elseif( $insert[ 'newsstory_rating' ] == 2 )
							{
								$insert[ 'newsstory_rating_line' ] = $templates -> exectemplate( $main_templates[ 'news_story_rating_2stars_html' ], $main_templates[ 'news_story_rating_2stars_php' ], $insert );
							}
							elseif( $insert[ 'newsstory_rating' ] < 2 )
							{
								$insert[ 'newsstory_rating_line' ] = $templates -> exectemplate( $main_templates[ 'news_story_rating_1star_html' ], $main_templates[ 'news_story_rating_1star_php' ], $insert );
							}
						}
					}
				}

				if( $user[ 'user_status' ] == 2 and $insert[ 'newsstory_author' ] == $user[ 'user_name' ] )
				{
					$insert[ 'newsstory_edit' ] = $templates -> exectemplate( $main_templates[ 'news_story_editlink_html' ], $main_templates[ 'news_story_editlink_php' ], $insert );
				}
				else
				{
					$insert[ 'newsstory_edit' ] = "";
				}

				if( $insert[ 'newsstory_extendedstory' ] )
				{
					$insert[ 'newsstory_story' ] .= $templates -> exectemplate( $main_templates[ 'news_story_more_html' ], $main_templates[ 'news_story_more_php' ], $insert );
				}
				elseif( $insert[ 'newsstory_link' ] )
				{
					$insert[ 'newsstory_story' ] .= $templates -> exectemplate( $main_templates[ 'news_story_link_html' ], $main_templates[ 'news_story_link_php' ], $insert );
				}

				if( $newsstory_fields )
				{
					$newsstory_fields_array = explode( "|", $newsstory_fields );

					for( $f = 0; $f < 24; $f++ )
					{
						$field = $f + 1;
						$insert[ 'newsstory_extra' . $field ] = $system -> decode( $newsstory_fields_array[ $f ] );
					}
				}
				else
				{
					for( $f = 1; $f < 25; $f++ )
					{
						$insert[ 'newsstory_extra' . $f ] = "";
					}
				}

				if( $insert[ 'newsstory_tags' ] )
				{
					$tags = explode( ",", $insert[ 'newsstory_tags' ] );
					$tags_array = array();

					foreach( $tags as $tag )
					{
						if( $tag )
						{
							$insert[ 'newsstory_tag' ] = ltrim( rtrim( $tag ) );
							$insert[ 'newsstory_tag_seo' ] = $system -> doseo( $insert[ 'newsstory_tag' ] );
							$tags_array[ ] = $templates -> exectemplate( $main_templates[ 'news_story_tags_list_html' ], $main_templates[ 'news_story_tags_list_php' ], $insert );
						}
					}

					$insert[ 'newsstory_tags_list' ] = implode( ",", $tags_array );
					$insert[ 'newsstory_tags' ] = $templates -> exectemplate( $main_templates[ 'news_story_tags_html' ], $main_templates[ 'news_story_tags_php' ], $insert );
				}

				if( $preferences[ 'news_window_url' ] )
				{
					$insert[ 'newsstory_story' ] = str_replace( " rel=\"nofollow\"", " rel=\"nofollow\" onclick=\"window.open(this.href);return false;\"", $insert[ 'newsstory_story' ] );
				}

				if( $preferences[ 'news_remove_nofollow' ] )
				{
					if( $preferences[ 'news_remove_nofollow_age' ] )
					{
						if ( $insert[ 'newsstory_date' ] > $news_nofollow_age )
						{
							$insert[ 'newsstory_story' ] = str_replace( " rel=\"nofollow\"", "", $insert[ 'newsstory_story' ] );
						}
					}
					else
					{
						$insert[ 'newsstory_story' ] = str_replace( " rel=\"nofollow\"", "", $insert[ 'newsstory_story' ] );
					}
				}

				$insert[ 'newsstory_date' ] = $system -> convertdate( $insert[ 'newsstory_date' ], $preferences[ 'news_dateformat' ], $preferences[ 'website_timezone' ] );

				if( $preferences[ 'news_2columns' ] )
				{

					if( !$newsrow )
					{
						$insert[ 'news_story' ] .= $templates -> exectemplate( $main_templates[ 'news_story_2columns_header_html' ], $main_templates[ 'news_story_2columns_header_php' ], $insert );
						$newsrow = 1;
					}
					elseif( $newsrow == 1 )
					{
						$insert[ 'news_story' ] .= $templates -> exectemplate( $main_templates[ 'news_story_2columns_middle_html' ], $main_templates[ 'news_story_2columns_middle_php' ], $insert );
						$newsrow = 2;
					}
				}

				$insert[ 'news_story' ] .= $templates -> exectemplate( $main_templates[ 'news_story_html' ], $main_templates[ 'news_story_php' ], $insert );

				if( $preferences[ 'news_2columns' ] and $newsrow == 2 )
				{
					$insert[ 'news_story' ] .= $templates -> exectemplate( $main_templates[ 'news_story_2columns_footer_html' ], $main_templates[ 'news_story_2columns_footer_php' ], $insert );
					$newsrow = 0;
				}
			}


			if( $preferences[ 'news_2columns' ] and $newsrow == 1 )
			{
				$insert[ 'news_story' ] .= $templates -> exectemplate( $main_templates[ 'news_story_2columns_middle_html' ], $main_templates[ 'news_story_2columns_middle_php' ], $insert );
				$insert[ 'news_story' ] .= $templates -> exectemplate( $main_templates[ 'news_story_2columns_footer_html' ], $main_templates[ 'news_story_2columns_footer_php' ], $insert );
			}

			if( $preferences[ 'news_max_archive' ] )
			{
				if( $preferences[ 'news_forum_comments' ] )
				{
					$newsstory_threads = array();
					$query = $database -> dbquery( "SELECT newsstory_thread FROM " . DB_PREFIX . "esselbach_ct_newsstories WHERE " . $newsstory_status . " AND newsstory_sticky = '0' AND newsstory_frontpage = '1' AND (newsstory_website = '0' OR newsstory_website = '" . $preferences[ 'current_website' ] . "')" . $news_expire_sql . " ORDER BY newsstory_position DESC, newsstory_date DESC LIMIT " . intval( $preferences[ 'news_max_stories' ] ) . "," . intval( $preferences[ 'news_max_archive' ] ) );

					if( $database -> dbrows( $query ) )
					{
						while( list( $newsstory_thread ) = $database -> dbrow( $query ) )
						{
							if( $newsstory_thread )
							{
								$newsstory_threads[ ] = "'" . $newsstory_thread . "'";
							}
						}

						$newsstory_threads_comments = $uwrapper -> getcomments( $newsstory_threads );
					}
				}
				$query = $database -> dbquery( "SELECT newsstory_id, newsstory_author, newsstory_title, newsstory_seo, newsstory_description, newsstory_channels, newsstory_status, newsstory_teaser, newsstory_date, newsstory_rating, newsstory_votes, newsstory_comments, newsstory_thread, newsstory_source FROM " . DB_PREFIX . "esselbach_ct_newsstories WHERE " . $newsstory_status . " AND newsstory_sticky = '0' AND newsstory_frontpage = '1' AND (newsstory_website = '0' OR newsstory_website = '" . $preferences[ 'current_website' ] . "')" . $news_expire_sql . " ORDER BY newsstory_position DESC, newsstory_date DESC LIMIT " . intval( $preferences[ 'news_max_stories' ] ) . "," . intval( $preferences[ 'news_max_archive' ] ) );

				if( $database -> dbrows( $query ) )
				{
					$insert[ 'news_archive' ] = $templates -> exectemplate( $main_templates[ 'news_archive_frontpage_header_html' ], $main_templates[ 'news_archive_frontpage_header_php' ], $insert );

					while( list( $insert[ 'newsstory_id' ], $insert[ 'newsstory_author' ], $insert[ 'newsstory_title' ], $insert[ 'newsstory_seo' ], $insert[ 'newsstory_description' ], $insert[ 'newsstory_channels_keys' ], $insert[ 'newsstory_status' ], $insert[ 'newsstory_teaser' ], $insert[ 'newsstory_date' ], $insert[ 'newsstory_rating' ], $insert[ 'newsstory_votes' ], $insert[ 'newsstory_comments' ], $insert[ 'newsstory_thread' ], $insert[ 'newsstory_source' ] ) = $database -> dbrow( $query ) )
					{
						if( $preferences[ 'news_forum_comments' ] )
						{
							if( isset( $newsstory_threads_comments[ $insert[ 'newsstory_thread' ] ] ) )
							{
								$insert[ 'newsstory_comments' ] = $newsstory_threads_comments[ $insert[ 'newsstory_thread' ] ];
							}
						}
						$insert[ 'newsstory_title' ] = htmlspecialchars( $insert[ 'newsstory_title' ] );
						$insert[ 'newsstory_author' ] = htmlspecialchars( $insert[ 'newsstory_author' ] );
						$insert[ 'newsstory_source' ] = htmlspecialchars( $insert[ 'newsstory_source' ] );

						if( $insert[ 'newsstory_source' ] )
						{
							$insert[ 'newsstory_author_by' ] = $templates -> exectemplate( $main_templates[ 'news_story_author_contributed_html' ], $main_templates[ 'news_story_author_contributed_php' ], $insert );
						}
						else
						{
							$insert[ 'newsstory_author_by' ] = $templates -> exectemplate( $main_templates[ 'news_story_author_posted_html' ], $main_templates[ 'news_story_author_posted_php' ], $insert );
						}

						$newsstory_channels = array();
						if( $insert[ 'newsstory_channels_keys' ] )
						{
							$channelsids = explode( ",", $insert[ 'newsstory_channels_keys' ] );
							foreach( $channelsids as $channelid )
							{
								$newsstory_channels[] = $channelslist[ $channelid ];
							}
						}
						$insert[ 'newsstory_channels' ] = implode(", ", $newsstory_channels );

						$insert[ 'newsstory_description' ] = htmlspecialchars( $insert[ 'newsstory_description' ] );
						if( $preferences[ 'news_allow_rating' ] and $insert[ 'newsstory_votes' ] )
						{
							if( $insert[ 'newsstory_rating' ] == 5 )
							{
								$insert[ 'newsstory_rating_line' ] = $templates -> exectemplate( $main_templates[ 'news_story_rating_5stars_html' ], $main_templates[ 'news_story_rating_5stars_php' ], $insert );
							}
							elseif( $insert[ 'newsstory_rating' ] == 4 )
							{
								$insert[ 'newsstory_rating_line' ] = $templates -> exectemplate( $main_templates[ 'news_story_rating_4stars_html' ], $main_templates[ 'news_story_rating_4stars_php' ], $insert );
							}
							elseif( $insert[ 'newsstory_rating' ] == 3 )
							{
								$insert[ 'newsstory_rating_line' ] = $templates -> exectemplate( $main_templates[ 'news_story_rating_3stars_html' ], $main_templates[ 'news_story_rating_3stars_php' ], $insert );
							}
							elseif( $insert[ 'newsstory_rating' ] == 2 )
							{
								$insert[ 'newsstory_rating_line' ] = $templates -> exectemplate( $main_templates[ 'news_story_rating_2stars_html' ], $main_templates[ 'news_story_rating_2stars_php' ], $insert );
							}
							elseif( $insert[ 'newsstory_rating' ] < 2 )
							{
								$insert[ 'newsstory_rating_line' ] = $templates -> exectemplate( $main_templates[ 'news_story_rating_1star_html' ], $main_templates[ 'news_story_rating_1star_php' ], $insert );
							}
						}
						else
						{
							$insert[ 'newsstory_rating_line' ] = "";
						}

						$insert[ 'news_archive' ] .= $templates -> exectemplate( $main_templates[ 'news_archive_frontpage_html' ], $main_templates[ 'news_archive_frontpage_php' ], $insert );
					}

					$insert[ 'news_archive' ] .= $templates -> exectemplate( $main_templates[ 'news_archive_frontpage_footer_html' ], $main_templates[ 'news_archive_frontpage_footer_php' ], $insert );
				}
			}
		}
		else
		{
			$insert[ 'news_story' ] = $templates -> exectemplate( $main_templates[ 'news_empty_html' ], $main_templates[ 'news_empty_php' ], $insert );
		}
	}

	if( $preferences[ 'news_archivelink_frontpage' ] )
	{
		$query = $database -> dbquery( "SELECT newsstory_date FROM " . DB_PREFIX . "esselbach_ct_newsstories WHERE " . $newsstory_status . " AND (newsstory_website = '0' OR newsstory_website = '" . $preferences[ 'current_website' ] . "')" . $news_expire_sql . " ORDER BY newsstory_id DESC LIMIT 1" );
		list( $last_date ) = $database -> dbrow( $query );
		list( $last_year, $last_month, $last_day ) = explode( "-", $last_date );
		$insert[ 'newsstory_month_id' ] = $last_year . $last_month;
		$insert[ 'news_archive_link' ] = $templates -> exectemplate( $main_templates[ 'news_archive_html' ], $main_templates[ 'news_archive_php' ], $insert );
	}
	else
	{
		$insert[ 'news_archive_link' ] = "";
	}

	if( $preferences[ 'news_navigation' ] )
	{
		$insert[ 'news_footer' ] = $templates -> exectemplate( $main_templates[ 'news_footer_html' ], $main_templates[ 'news_footer_php' ], $insert );
	}
	else
	{
		$insert[ 'news_footer' ] = "";
	}

	echo $templates -> exectemplate( $main_templates[ 'news_layout_main_html' ], $main_templates[ 'news_layout_main_php' ], $insert );
	echo $templates -> exectemplate( $main_templates[ 'site_footer_html' ], $main_templates[ 'site_footer_php' ], $insert );
}
?>